#
# scpkt8.rb
#
# $Id: scpkt8.rb,v 1.1 2000/11/21 03:02:06 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


nx = 37
xmin = 0
xmax = 360
ymin = 0
ymax = 180
drad = PI/180

alon = NArray.sfloat(nx)
alat = NArray.sfloat(nx)
r = NArray.sfloat(nx)
a = NArray.sfloat( nx)

#-- data ---
alon.indgen(xmin, (xmax-xmin)/(nx-1).to_f)
alat.indgen(ymin, (ymax-ymin)/(nx-1).to_f)
r.fill!(1.0)

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i

sgopn iws

sgfrm
sglset('LDEG', true)

#---------------- 3-D ------------------
scsorg(1.0, 0.0, 0.0, 0.0)
scstrn(3)
scstrf

scseye(5.0, 1.0, 2.0)
scsobj(0.0, 0.0, 0.0)
scsprj

scspmt(10)
scspmi(1)
scspms(0.01)

for i in 0..nx-1
  a.fill!(alat[i])
  scplu(r, a, alon)
  scpmu(r, a, alon)
end

sgcls


