#
# sgpk09.rb
#
# $Id: sgpk09.rb,v 1.1 2000/11/21 03:02:08 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


kmax = 4
nn = 73
dd = 2.0
ux = NArray.sfloat(nn)
uy = NArray.sfloat(nn)

#-- data ---
xorg = NArray[2.5, 7.5, 2.5, 7.5]
yorg = NArray[7.5, 7.5, 2.5, 2.5]

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
sgopn iws

sgfrm

sgswnd(0.0, 10.0, 0.0, 10.0)
sgsvpt(0.0, 1.0, 0.0, 1.0)
sgstrn(1)
sgstrf

sgstxs(0.03)
sgstxi(3)
sgstxc(0)

sgsplc('K=1')

for k in 0..kmax-1
  sgslni(1)
  sglnu(xorg[k]-dd, yorg[k], xorg[k]+dd, yorg[k])
  sglnu(xorg[k], yorg[k]-dd, xorg[k], yorg[k]+dd)

  for i in 0..nn-1
    th = 2*PI*i/(nn-1)
    ux[i] = xorg[k] + dd*cos(th+k*PI/7)
    uy[i] = yorg[k] + dd*sin((k+1)*th)
  end

  sgspli(2)
  sgsplt(k+1)
  sglset('LCHAR', true)
  sgplu(ux, uy)
  sglset('LCHAR', false)
  sgnplc
end

sgcls

