#
# test01.rb
#
# $Id: test01.rb,v 1.1 2000/11/22 14:35:59 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


nx = 19
ny = 19
xmin = 0
xmax = 360
ymin = -90
ymax = +90
dx1 = 20
dx2 = 60
dy1 = 10
dy2 = 30
drad = PI / 180
dz = 0.05
dp = 0.2
p = NArray.new(Float, nx, ny)

#-- data ---
for j in 0..ny-1
  for i in 0..nx-1
    alon = (xmin + (xmax-xmin)*i/(nx-1)) * drad
    alat = (ymin + (ymax-ymin)*j/(ny-1)) * drad
    slat = sin(alat)
    p[i,j] = cos(alon) * (1-slat**2) * sin(2*PI*slat) + dz
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

rmiss = glrget('RMISS')
sglset('LSOFTF', false)

grfrm
grswnd(xmin, xmax, ymin, ymax)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

uestlv(rmiss, -dp, 201)
uestlv(dp, dp*2, 401)
uestlv(dp*2, rmiss, 402)
uetone(p)

uxaxdv('B', dx1, dx2)
uxaxdv('T', dx1, dx2)
uxsttl('B', 'LONGITUDE', 0.0)

uyaxdv('L', dy1, dy2)
uyaxdv('R', dy1, dy2)
uysttl('L', 'LATITUDE', 0.0)

udgclb(p, dp)
udcntr(p)

grcls

