#
# u2d7.rb
#   $Id: u2d7.rb,v 1.2 2000/11/18 19:03:46 keiko Exp $
#


require "narray"
require "numru/dcl"
include NumRu::DCL
include Math


nx = 21
ny = 21
xmin = -10
xmax = 10
ymin = -10
ymax = 10
dx1 = 1
dx2 = 5
dy1 = 1
dy2 = 5
kmax = 5
pmin = 0
pmax = 1
u = NArray.sfloat(nx, ny)
v = NArray.sfloat(nx, ny)
p = NArray.sfloat(nx, ny)
pi = NArray.sfloat(2, kmax+1)

#-- data ---
for j in 0..ny-1
  for i in 0..nx-1
    x = xmin + (xmax-xmin)*i/(nx-1).to_f
    y = ymin + (ymax-ymin)*j/(ny-1).to_f
    u[i,j] =  x
    v[i,j] = -y
    p[i,j] = exp(-x**2/64 -y**2/25)
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

sglset('LSOFTF', true)
grfrm

grswnd(xmin, xmax, ymin, ymax)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

uxaxdv('B', dx1, dx2)
uxaxdv('T', dx1, dx2)
uxsttl('B', 'X-axis', 0.0)
uxmttl('T', 'FIGURE TITLE', 0.0)

uyaxdv('L', dy1, dy2)
uyaxdv('R', dy1, dy2)
uysttl('L', 'Y-axis', 0.0)

uglset('LUNIT', true)
ugrset('VXUOFF', 0.04)
ugsut('X', 'U')
ugsut('Y', 'V')
ugvect(u, v)

udlset('LABEL', false)
udlset('LMSG', false)
udgclb(p, 0.1)
udcntr(p)

dp = (pmax-pmin)/kmax.to_f
for k in 1..kmax
  tlev1 = (k-1)*dp
  tlev2 = tlev1 + dp
  ipat  = 600 + k - 1
  uestlv(tlev1, tlev2, ipat)
end
uetone(p)

#-- ȡС ----
grswnd(0.0, 1.0, pmin, pmax)
grsvpt(0.85, 0.9, 0.45, 0.75)
grstrn(1)
grstrf

for k in 1..kmax+1
  pi[0,k-1] = pmin + (k-1)*dp
  pi[1,k-1] = pmin + (k-1)*dp
end

udcntr(pi)
uetone(pi)

slpvpr(3)
uzlset('LABELYR', true)
uzfact(0.8)
uysfmt('(F4.1)')
uyaxdv('R', dp, dp)

grcls
